/*
 * MainFrame.java
 *
 * Created on December 15, 2006, 10:01 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

import javax.swing.JFrame;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JSeparator;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;

/**
 *
 * @author Krzysztof Jurczuk
 */
public class MainFrame extends JFrame {
    ProcessOfAllocation processOfAllocation;
    Runtime rt;
    Vector vector;
    boolean allocate;   
    
    /** Creates a new instance of MainFrame */
    public MainFrame() {
        rt = rt = java.lang.Runtime.getRuntime();        
        allocate = false;   
        vector = new Vector();
        
        initComponents();
        this.setSize(240, 150);
        freeMemoryJTextField.setText( String.valueOf( rt.freeMemory() ) );
        totalMemoryJTextField.setText( String.valueOf( rt.totalMemory() ) );           
    }
    
    //fill the main panel using JButtons, JLabels and JTextFields
    void initComponents(){
       java.awt.GridBagConstraints gridBagConstraints;

        totalMemoryJTextField = new JTextField();
        freeMemoryJTextField = new JTextField();
        freeMemoryJLabel = new JLabel();
        totalMemoryJLabel = new JLabel();
        allocateMemoryJButton = new JButton();
        freeMemoryJButton = new JButton();
        jSeparator = new JSeparator();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        totalMemoryJTextField.setPreferredSize(new java.awt.Dimension(110, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 3);
        getContentPane().add(totalMemoryJTextField, gridBagConstraints);

        freeMemoryJTextField.setPreferredSize(new java.awt.Dimension(110, 19));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 3);
        getContentPane().add(freeMemoryJTextField, gridBagConstraints);

        freeMemoryJLabel.setText("Free Memory");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(1, 1, 1, 3);
        getContentPane().add(freeMemoryJLabel, gridBagConstraints);

        totalMemoryJLabel.setText("Total Memory");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(1, 3, 1, 3);
        getContentPane().add(totalMemoryJLabel, gridBagConstraints);

        allocateMemoryJButton.setText("Start allocating memory");
        allocateMemoryJButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                allocateMemoryJButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(2, 0, 2, 0);
        getContentPane().add(allocateMemoryJButton, gridBagConstraints);

        freeMemoryJButton.setText("Free memory");
        freeMemoryJButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                clearMemoryJButtonActionPerformed(evt);
            }
        });
        freeMemoryJButton.setMaximumSize(new java.awt.Dimension(145, 23));
        freeMemoryJButton.setMinimumSize(new java.awt.Dimension(145, 23));
        freeMemoryJButton.setPreferredSize(new java.awt.Dimension(145, 23));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(2, 0, 2, 0);
        getContentPane().add(freeMemoryJButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(4, 0, 4, 0);
        getContentPane().add(jSeparator, gridBagConstraints);

        pack();
    }
    
    //reaction for push the button "Start/stop allocating memory"
    private void allocateMemoryJButtonActionPerformed(ActionEvent evt) {
        // TODO add your handling code here:
        if( allocate ){
            freeMemoryJButton.setEnabled( true );
            allocateMemoryJButton.setText( "Start allocating memory" );
            allocate = false;
            processOfAllocation.interrupt();                        
            
            freeMemoryJTextField.setText( String.valueOf (rt.freeMemory () ) );
            totalMemoryJTextField.setText( String.valueOf (rt.totalMemory () ) );
            
            //SO NOW WE USE OUR GENERATE VECTOR
            
            //!!!!!!!!!!!AND AFTER USE WE SHOULD CLEAR THEM!!!!!!!!!!!!!!!!!!!!
            //!!!!!!OTHERWISE GARBAGE COLLECTOR WILL NOT DELETE THEM!!!!!!!!!!!
            //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        }      
        else{
            freeMemoryJButton.setEnabled( false );
            allocate = true;
            allocateMemoryJButton.setText( "Stop allocating memory" );
            processOfAllocation = new ProcessOfAllocation( vector );
            processOfAllocation.start();             
        }
    }   
    
    //reaction for push the button "Clear memory"
    private void clearMemoryJButtonActionPerformed(ActionEvent evt) {
        // TODO add your handling code here:
        vector.clear();        
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
        new MainFrame().setVisible(true);               
    }    
    
    private JButton allocateMemoryJButton;
    private JButton freeMemoryJButton;
    private JLabel freeMemoryJLabel;
    private JLabel jLabel1;
    private JLabel totalMemoryJLabel;
    private JTextField totalMemoryJTextField;
    private JTextField freeMemoryJTextField;
    private JSeparator jSeparator;
}