// example1.cpp : Defines the entry point for the console application.
//

//EXAMPLE TO RATIONAL PURIFY
//made by Krzysztof Jurczuk

#include "stdafx.h"
#include <iostream>
#include <string.h>

using namespace std;


//when we assign for pointer string1 another pointer (string2)
//later we cannot delete 
//memory allocated in instruction: char* string1 = new char[100];
//and we will have errors:
//1.leak memory
//2.doubly free memory (delete string2)
void bug1(){
	const int MAX = 100;

	char* string1 = new char[100];
	char* string2 = new char[100];

	string1 = string2;

	delete string1;
	delete string2;					// FFM: Freeing freed memory 
				
}							

//we should use in pairs: new and delete or alloc and free
void bug2(){
	const int MAX = 100;

	char* string = new char[100];	

	free( string );					//FMM: Freeing mismatched memory
	//delete string;
}

//we should remmeber about NULL byte to terminate the string
void bug3(){
	static char *string1 = "Rational Purify";		
	
	int length= strlen( string1 );
	//int length= strlen( string1 ) + 1;

	char* string2 = new char[ length ];

	strncpy( string2, string1, length );	

	
	printf( "%s\n", string2 );		//ABR: Array bounds read	
}

int main(int argc, char* argv[])
{
	cout << "Begin" << endl;

	bug1();							//MLK: Memory leak

	bug2();

	bug3();	


	cout << "End" << endl;

	return 0;
}

